#include <stdio.h>
#include "mpi.h"

int main(int argc, char *argv[]) {
	int my_rank, p, next_rank, prev_rank, other_rank, tag1 = 5;
	MPI_Status status;

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
	MPI_Comm_size(MPI_COMM_WORLD, &p);

	if (my_rank == p - 1)  {
		next_rank = 0;
 	} else {
		next_rank = my_rank + 1;
	}

	if (my_rank == 0)  {
		prev_rank = p - 1;
 	} else {
		prev_rank = my_rank - 1;
	}

	MPI_Send(&my_rank, 1, MPI_INT, next_rank, tag1, MPI_COMM_WORLD);
	MPI_Recv(&other_rank, 1, MPI_INT, prev_rank, tag1, MPI_COMM_WORLD, &status);

	printf("I am process %d and I received the value %d.\n", my_rank, other_rank);

	MPI_Finalize();

	return(0);
}

