#include <stdio.h>
#include "mpi.h"

int main(int argc, char *argv[])  
{
	int my_rank, p, i, res, finres, num, N;
	int source, target;
	int tag1=50, tag2=60, tag3=70;
	int data[100];
	MPI_Status status;

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
	MPI_Comm_size(MPI_COMM_WORLD, &p);

	if (my_rank == 0)  {
		printf("Enter size of vector: ");
		scanf("%d", &N);
		
		printf("Enter %d vector elements: ", N); 
		for (i = 0; i < N; i++) {
			scanf("%d", &data[i]);
		}

		for (target = 1; target < p; target++) {
			MPI_Send(&N, 1, MPI_INT, target, tag1, MPI_COMM_WORLD);
		}

		num = N / p;
		i   = num;
		for (target = 1; target < p; target++)  {
			MPI_Send(&data[i], num, MPI_INT, target, tag2, MPI_COMM_WORLD);
			i += num;
		}
	} else {
		MPI_Recv(&N, 1, MPI_INT, 0, tag1, MPI_COMM_WORLD, &status);
		num = N / p;
		MPI_Recv(&data[0], num, MPI_INT, 0, tag2, MPI_COMM_WORLD, &status);
	}

	res = 0;
	for (i = 0; i < num; i++) {
		res += (data[i] * data[i]);
	}

	if (my_rank != 0) {
		MPI_Send(&res, 1, MPI_INT, 0, tag3, MPI_COMM_WORLD);
	} else {
		finres = res;

		printf("\nResult of process %d: %d\n", my_rank, res);

		for (source = 1; source < p; source++) {
			MPI_Recv(&res, 1, MPI_INT, source, tag3, MPI_COMM_WORLD, &status);
			finres += res;
			printf("\nResult of process %d: %d\n", source, res);
		}
		printf("\n\n\nFinal result: %d\n", finres);
	}

	MPI_Finalize();

	return(0);
}

