#include <stdio.h>
#include "mpi.h"

int main(int argc, char *argv[])
{
	int my_rank, p, i, res, finres, start, end, num, N;

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
	MPI_Comm_size(MPI_COMM_WORLD, &p);

	if (my_rank == 0) {
		printf("Enter last number: ");
		scanf("%d", &N);
	}

	MPI_Bcast(&N, 1, MPI_INT, 0, MPI_COMM_WORLD);

	res   = 0;
	num   = N / p;
	start = (my_rank * num) + 1;
	end   = start + num;

	for (i = start; i < end; i++) {
		res += (i * i);
	}

	printf("\nResult of process %d: %d\n", my_rank, res);

	MPI_Reduce(&res, &finres, 1, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);

	if (my_rank == 0) {
		printf("\n Total result for N = %d is equal to : %d \n", N, finres);
	}

	MPI_Finalize();

	return(0);
}

