#include <stdio.h>
#include "mpi.h"

int main(int argc, char *argv[])
{
	int my_rank, p, i, num, b, size, A[100], local_A[100];

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
	MPI_Comm_size(MPI_COMM_WORLD, &p);

	if (my_rank == 0) {
		printf("Calculating b * A\n\n");
		printf("Enter value for b: ");
		scanf("%d", &b);
		printf("Enter size of vector A:");
		scanf("%d", &size);
		printf("Enter values of vector elements: ");
		for (i = 0; i < size; i++) {
			scanf("%d", &A[i]);
		}
	}

	MPI_Bcast(&size, 1, MPI_INT, 0, MPI_COMM_WORLD);
	MPI_Bcast(&b, 1, MPI_INT, 0, MPI_COMM_WORLD);

	num = size / p;

	MPI_Scatter(A, num, MPI_INT, local_A, num, MPI_INT, 0, MPI_COMM_WORLD);

	for (i = 0; i < num; i++) {
	    	local_A[i] *= b;
	}

	printf("\nLocal results for process %d:\n", my_rank);
	for (i = 0; i < num; i++) {
		printf("%d ", local_A[i]);
	}
	printf("\n\n");

	MPI_Gather(local_A, num, MPI_INT, A, num, MPI_INT, 0, MPI_COMM_WORLD);

	if (my_rank == 0) {
		printf("\nFinal result:\n");
		for (i = 0; i < size; i++) {
			printf("%d ", A[i]);
		}
		printf("\n\n");
	}

	MPI_Finalize();

	return(0);
}

